#include <avr/io.h>
#include <avr/interrupt.h>

void InitHardware(void)
{
    DDRB = (1<<PB0); /* pin connected to LED is output pin */

    /* initialize timer 1 */
    TCCR1B = (1<<CS11) | (1<<CS10); /* prescaler = clk/64 */
    TIMSK |= (1<<TOIE1); /* enable overflow interrupt */
}

ISR(TIMER1_OVF_vect) /* timer 1 overflow interrupt */
{
    PORTB ^= (1<<PB0); /* toggle LED */
    // DoSomePeriodicalStuff();
}

int main(void)
{
    InitHardware();
    sei(); /* globally enable interrupts */
    while(1) {
        // DoSomeBackgroundStuff();
    }
}