#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SIZE_OF_ARRAY       24u

unsigned int source[SIZE_OF_ARRAY];
unsigned int dest[SIZE_OF_ARRAY];

void BubbleSort(unsigned int* s, unsigned int size)
{
    unsigned int i,j,temp;
    for(i=1; i<size; i++) {
        for(j=0; j<(size-i); j++) {
            if(s[j] > s[j+1])
            {
                temp       = s[j];
                s[j]   = s[j+1];
                s[j+1] = temp;
            }
        }
    }
    printf("\nExecuted loop %d times to sort %d entries.", (size*size-size)/2, size);
}

void MergeSortedArrays( unsigned int* d,    /* destination */
                        unsigned int* s,    /* source */
                        unsigned int size1,
                        unsigned int size2 )
{
    unsigned int p;
    unsigned int i1 = 0;
    unsigned int i2 = size1;
    for (p=0; p<size1+size2; p++) {
        if (s[i1] < s[i2]) {
            d[p] = s[i1++];
            if (i1 == size1) {
                /* reached end of section 1,
                   so simply copy the rest */
                while (i2 < size1+size2) {
                    d[++p] = s[i2++];
                }
                break;
            }
        } else {
            d[p] = s[i2++];
            if (i2 == size1+size2) {
                /* reached end of section 2,
                   so simply copy the rest */
                while (i1 < size1) {
                    d[++p] = s[i1++];
                }
                break;
            }
        }
    }
}


int main()
{
    unsigned int i;

    printf("Filling array with random numbers between 0 and 99:\n");
    for(i=0; i<SIZE_OF_ARRAY; i++) {
        source[i] = rand() / (RAND_MAX / 100);
        printf("%d ",source[i]);
    }

    BubbleSort(&source[0], SIZE_OF_ARRAY / 2);                     /* Core 0 */
    BubbleSort(&source[SIZE_OF_ARRAY / 2], SIZE_OF_ARRAY / 4);     /* Core 1 */
    BubbleSort(&source[3 * SIZE_OF_ARRAY / 4], SIZE_OF_ARRAY / 4); /* Core 2 */

    MergeSortedArrays(dest, source, SIZE_OF_ARRAY / 2, SIZE_OF_ARRAY / 4);
    memcpy(source, dest, sizeof(unsigned int) * 3 * SIZE_OF_ARRAY / 4);
    MergeSortedArrays(dest, source, 3 * SIZE_OF_ARRAY / 4, SIZE_OF_ARRAY / 4);

    printf("\n\nOutput array after sorting:\n");
    for(i=0; i<SIZE_OF_ARRAY; i++) {
        printf("%d ",dest[i]);
    }
    printf("\n");
    return 0;
}